;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine 
;;  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
.include "cpctelera.h.s"
.include "man/entityman.h.s"
.include "man/patrolman.h.s"

.area _DATA

.area _CODE
.globl cpct_disableFirmware_asm
.globl cpct_setVideoMode_asm
.globl cpct_getRandom_mxor_u8_asm
.globl Key_A
.globl Key_D
.globl Key_Space
.globl Key_R
.globl Key_E
.globl Key_W
.globl Key_S
.globl Key_0
.globl Key_1
.globl Key_2
.globl Key_Esc
.globl Key_P

hero: 
   .db 32, 200 ;; X, Y
   .db 0, 0    ;; VX, VY
   .db 12, 0  ;; W, H
   .dw #_ship_0 ;; Sprite
   .db 0xC0, 0x00 ;; Memory last video
   .db e_st_no_ai, 1, 0, 0, e_st_no_ai
   .dw 0x0000
   .db e_cmp_player
   .db e_cmp2_render
   .dw ship_standard_animation
   .db -1   ;;De momento controlamos las vidas desde otra variable
   .db -1
   .db 1, 1, 127

enemy::
   .db 0, 40, 0, 0, 9, 24
   .dw #_explosion_0
   .db 0xC0, 0x00, e_st_stand_by, 0, 0, 15,e_st_patrol
   .dw 0x0000
   .db e_cmp_enemy
   .db e_cmp2_render
   .dw generate_enemy_basic_animation
   .db 1
   .db #0x05
   .db 1, 1, 15

enemy_bomb::
   .db 0, 0, 0, 0, 9,24
   .dw nullptr
   .db 0xC0, 0x00, e_st_stand_by, 0, 0, 31, e_st_patrol
   .dw 0x0000
   .db e_cmp_enemy
   .db e_cmp2_bomb
   .dw generate_enemy_bomb_standard_animation
   .db 5
   .db #0x0A
   .db 1, 2, 31

enemy_a::
   .db 20, 40, 0, 4, 3 ,20
   .dw #_asteroid_0
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 0,e_st_no_ai
   .dw 0x0000
   .db e_cmp_enemy_a
   .db e_cmp2_enemy_a
   .dw asteroid_animation
   .db 1
   .db #0x10
   .db 0, 0, 0

enemy_torreta::
   .db 20, 20, 0, 3, 7, 15
   .dw #_enemy_basic_3
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 0,e_st_no_ai
   .dw 0x0000
   .db e_cmp_torret
   .db e_cmp2_torret
   .dw torreta_animation
   .db 1
   .db #0x10
   .db 0, 0, 3

enemy_fast::
   .db 0, 0, 0, 0, 6, 10
   .dw #_enemy_fast_0
   .db 0xC0, 0x00, e_st_stand_by, 0, 0, 30,e_st_patrol
   .dw 0x0000
   .db e_cmp_enemy
   .db e_cmp2_fast
   .dw generate_enemy_fast_standard_animation
   .db 2
   .db #0x10
   .db 2, 2, 15

heart::
   .db 0, 0, 0, 4, 4, 13
   .dw #_bonusheart_0
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 0,e_st_no_ai
   .dw 0x0000
   .db e_cmp_heart
   .db e_cmp2_heart
   .dw heart_animation
   .db 1
   .db #0x10
   .db 0, 0, 0

double_shoot::
   .db 0, 0, 0, 4, 5, 16
   .dw #_doubleshoot_0
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 0,e_st_no_ai
   .dw 0x0000
   .db e_cmp_doubleShoot
   .db e_cmp2_doubleShoot
   .dw double_animation
   .db 1
   .db #0x10
   .db 0, 0, 0

double_score::
   .db 0, 0, 0, 4, 5, 16
   .dw #_doubleshoot_2
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 0,e_st_no_ai
   .dw 0x0000
   .db e_cmp_doubleScore
   .db e_cmp2_doubleScore
   .dw score_animation
   .db 1
   .db #0x10
   .db 0, 0, 0


bullet::
   .db 0, 0, 0, -10, 1, 8
   .dw _laser_ship
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 0,e_st_no_ai
   .dw 0x0000
   .db e_cmp_bullet
   .db e_cmp2_bullet
   .dw nullptr
   .db -1
   .db -1
   .db 0, 0, 0

bullet_ai::
   .db 0, 0, 0, 13, 1, 8
   .dw _enemy_laser
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 0,e_st_no_ai
   .dw 0x0000
   .db e_cmp_bullet
   .db e_cmp2_bullet
   .dw nullptr
   .db -1
   .db -1
   .db 0, 0, 0

bomb::
   .db 0, 0, 0, 7, 2, 8
   .dw nullptr
   .db 0xC0, 0x00, e_st_stand_by, 0, 0, 0, e_st_stand_by
   .dw 0x0000
   .db e_cmp_bomb
   .db e_cmp2_bullet
   .dw #bomb_animation
   .db -1
   .db -1
   .db 1, 2, 0  

explosion::
   .db 0, 0, 0, 0, 7, 22
   .dw #_explosion_0
   .db 0xC0, 0x00, e_st_no_ai, 0, 0, 5, e_st_no_ai
   .dw 0x0000
   .db e_cmp_animate
   .db e_cmp2_explosion
   .dw explosion_animation
   .db -1
   .db -1
   .db 0, 0, 0  

empty::
   .ds entity_size

esperar:
   ld a, (num_level)
   ld b, a
   ld a, #13
   sub b
   wait:
      halt
      dec a
   jr nz, wait
ret

_main::   
   call rendersys_init
   call clean_screen
   call starfield_init
   call menuman_init
   call menuman_run
   call clean_screen
   call patrolman_init

play:
   call restart_lifes
   ld hl, #hero
   call entityman_create
   
   ;call starfield_init
   
   call levelman_init

loop:

   call spawnman_rand_entity_update

   call entityman_getEntityVector_IX
   call inputsys_update

   call levelman_update

   call entityman_getEntityVector_IX
   call entityman_getNumEntities_A

   call aicontrolsys_update

   call entityman_getEntityVector_IX
   call entityman_getNumEntities_A

   call collisionsys_update

   call entityman_getEntityVector_IX
   call entityman_getNumEntities_A
   
   call physicssys_update
   call hero_update
   
   call starfield_update

   call entityman_getEntityVector_IX
   call entityman_getNumEntities_A

   call animation_update

   call rendersys_update

   call entityman_getEntityVector_IX
   call entityman_getNumEntities_A
   call entityman_destroy

   call cpct_waitVSYNC_asm
   call esperar

   ld a,(playing)
   or a
   jr nz,loop

end:
   call entityman_resetEntities
   call clean_screen
waitR:
   call starfield_update
	call render_stars
   call rendersys_draw_gameover_screen
   call render_score
   call render_level
   call esperar
   call inputsys_R
   ld a,(playing)
   or a
   jr nz,play

   jr waitR