;; 
;; ENTITY MANAGER HEADER
;; 

;; Declaración de variables
last_ptr_entity: .dw entity_array            ;; Puntero a la última entidad del vector
num_entities: .db 0                          ;; Cantidad de entidades que hay
entity_array: .ds entity_size * max_entities ;; Reserva del espacio de entidades

;; Tipos  
e_cmp_level      = 0b00000001
e_cmp_hero       = 0b00000010
e_cmp_dead_y     = 0b00000100
e_cmp_col        = 0b00001000
e_cmp_bounce_x   = 0b00010000
e_cmp_shoot      = 0b00100000
e_cmp_animate    = 0b01000000
e_cmp_dead       = 0b10000000
e_cmp_bullet     = e_cmp_dead_y
e_cmp_bomb       = e_cmp_bullet | e_cmp_animate
e_cmp_enemy      = e_cmp_bounce_x | e_cmp_col | e_cmp_shoot | e_cmp_animate
e_cmp_player     = e_cmp_animate | e_cmp_hero
e_cmp_enemy_a	 = e_cmp_dead_y | e_cmp_animate
e_cmp_heart      = e_cmp_enemy_a
e_cmp_doubleShoot= e_cmp_enemy_a
e_cmp_doubleScore= e_cmp_enemy_a
e_cmp_torret     = e_cmp_col | e_cmp_shoot | e_cmp_animate | e_cmp_dead_y
e_cmp2_fast      = e_cmp_enemy

e_cmp2_default     = 0b00000000
e_cmp2_killer      = 0b00000001
e_cmp2_badEntity   = 0b00000010
e_cmp2_bomb        = 0b00000100
e_cmp2_render      = 0b00001000
e_cmp2_heart0      = 0b00010000
e_cmp2_doubleShoot0= 0b00100000
e_cmp2_explosion   = 0b01000000
e_cmp2_doubleScore0= 0b10000000

e_cmp2_bullet     = e_cmp2_killer
e_cmp2_heart      = e_cmp2_enemy_a | e_cmp2_heart0
e_cmp2_e_bomb     = e_cmp2_bomb | e_cmp2_render
e_cmp2_enemy_a    = e_cmp2_bullet | e_cmp2_badEntity | e_cmp2_render
e_cmp2_doubleShoot= e_cmp2_enemy_a | e_cmp2_doubleShoot0
e_cmp2_doubleScore= e_cmp2_enemy_a | e_cmp2_doubleScore0
e_cmp2_torret     = e_cmp2_default | e_cmp2_badEntity
e_cmp2_fast       = e_cmp2_badEntity

;; Identificador de los datos de la entidad
e_x             = 0  ;; X
e_y             = 1  ;; Y
e_vx            = 2  ;; Velocidad Y
e_vy            = 3  ;; Velocidad X
e_w             = 4  ;; Anchura 
e_h             = 5  ;; Altura
e_spH           = 6  ;; Sprite
e_spL           = 7  ;; Sprite
e_lastVPH       = 8  ;; Memory Video anterior 
e_lastVPL       = 9  ;; Memory Video anterior
e_ai_st         = 10 ;; Estado IA
e_ai_x          = 11 ;; Posicion X hacia la donde moverse
e_ai_y          = 12 ;; Posicion Y hacia la donde moverse
e_ai_shoot      = 13 ;; Contador de disparo
e_ai_pre_st     = 14 ;; estado previo ia
e_ai_c_patrol_l = 15 ;; contador de patrulla
e_ai_c_patrol_h = 16 ;; contador de patrulla
e_cmp           = 17 ;; Tipo de entidad
e_cmp2          = 18
e_anim_ptrL     = 19 ;; Puntero a la animación
e_anim_ptrH     = 20 ;; Puntero a la animación
e_lives         = 21
e_score         = 22
e_ai_vx         = 23
e_ai_vy         = 24
e_ai_shoot_time = 25
entity_size     = 26 ;; Tamaño en bytes de una entidad
max_entities    = 30 ;; Máximo número de entidades


;; Estados de la IA
e_st_stand_by = 0 ;; Esperando
e_st_move_to  = 1 ;; Moverse hacia
e_st_no_ai    = 2 ;; No es IA
e_st_patrol	  = 3 ;; patrulla

;; Utilidad
nullptr = 0x0000

;; Funciones públicas
.globl entityman_getEntityVector_IX
.globl entityman_getNumEntities_A
.globl entityman_create
.globl entityman_destroy_entity
.globl entityman_destroy
.globl entityman_doForAll
.globl entityman_resetEntities