.include "man/heroman.h.s"
.include "man/entityman.h.s"

start_lifes = #4
lifes: .db #start_lifes
inmune_time: .db #inmune_max_time
double_shoot_time: .db #0

hero_update:
    ld a,(double_score_time)
    and a
    jr z,updateInmuneTime

    dec a
    ld (double_score_time),a

    updateInmuneTime:
    ld a,(inmune_time)
    and a
    jr z,updateDoubleShootTime

    dec a
    ld (inmune_time),a

    updateDoubleShootTime:
    ld a,(double_shoot_time)
    and a
    ret z

    dec a
    ld (double_shoot_time),a
ret


restart_lifes:
    ld a,#start_lifes
    ld (lifes),a
ret

hero_collision:
    ;;Comprobar inmunidad
    ld a,(inmune_time)
    and a
    ret nz   ;;Si es inmune

    ld a,(lifes)
    dec a
    ;;Comprobar vidas > 0
    sub #0
    call z,game_over   ;;Si no quedan vidas
    ret z

    ;;Bajar 1 vida
    ld a,(lifes)
    dec a
    ld (lifes), a

    ;;Borrar corazon de memoria de video
    ld hl, #posMem_heart
    ld bc, #heart_w + #dist_hearts

    sub #0
    jr z, delete_heart
    
    next_heart:
        add hl,bc
        dec a
        jr nz, next_heart

    delete_heart:
        ld e, l ;; Dirección de memoria anterior
        ld d, h ;; Dirección de memoria anterior
        ld a,#0x00          ;; A = 0 -> Color de fondo
        ld c,#heart_w       ;; Width
        ld b,#heart_h       ;; Height

    call cpct_drawSolidBox_asm

    ;;Poner inmunidad
    ld a, #inmune_max_time
    ld (inmune_time),a

    ;; Generamos explosion
    call entityman_getEntityVector_IX
    ld a, e_x(ix)
    add #3
    ld e_x(ix), a
    ld a, e_y(ix)
    add #3
    ld e_y(ix), a
    ld hl, #explosion
    ld a, #1 
    call spawnman_generate_entity 

    ;; Limpiamos el resto de la nave
    ld e, e_lastVPL(ix) ;; Dirección de memoria anterior
    ld d, e_lastVPH(ix) ;; Dirección de memoria anterior
    xor a               ;; A = 0 -> Color de fondo
    ld c, e_w(ix)      ;; Width
    ld b, e_h(ix)       ;; Height
    call cpct_drawSolidBox_asm

    ;; Posicionamos la nave en el spawn
    ld e_x(ix), #32
    ld e_y(ix), #200
    ld e_h(ix), #0
    ld e_vx(ix), #0
    ld e_vy(ix), #0

ret

heroman_addHeart:
    ;Comprobamos si estamos al maximo de vidas
    ld a,(lifes)
    ld b,#start_lifes
    sub b
    ret z

    ;;Añadimos 1 vida
    ld a,(lifes)
    inc a
    ld (lifes),a
ret

heroman_activeDoubleShoot:
    ld a,#max_double_shoot_time
    ld (double_shoot_time),a
ret