;; 
;; MENU MANAGER
;; 
charA = #0x41
charS = #0x53
charD = #0x44
charW = #0x57
color_lines = #0xFF
color_lines_v = #0x11

str_menu: .asciz "Ama My Retro"
str_press_0: .asciz "0. Start"
str_press_1: .asciz "1. Controls"
str_press_2: .asciz "2. Credits"
;;str_press_Space: .asciz "(space to return)"
str_ivan: .asciz "Ivan San Martin"
str_raquel: .asciz "Raquel Gonzalez"
str_carlos: .asciz "Carlos Garrido"
str_Move: .asciz "Move"
str_space: .asciz "(Space)"
str_Shoot: .asciz " Shoot"
str_esc: .asciz "(Esc)"
str_EndGame: .asciz "End Game"
str_pause: .asciz "PAUSE"
str_pause_min: .asciz "Pause"
str_P: .asciz "(P)"

esperar_menu:
   ld a, #13
   wait:
      halt
      dec a
   jr nz, wait
ret

menuman_pause:
	ld l,#3   ;;Foreground colour
    ld h,#0   ;;Background colour
    call cpct_setDrawCharM0_asm

    ld hl,#0xC33D   ;;Memoria de video
    ld iy,#str_pause    ;;Puntero a string
    call cpct_drawStringM0_asm
ret

menuman_run_pause::
	call clean_screen

	menuman_run_pause_loop::
		call starfield_update
		call render_stars
		call menuman_pause
		call esperar_menu

		call cpct_scanKeyboard_f_asm
		ld hl,#Key_P
		call cpct_isKeyPressed_asm
	jr z,menuman_run_pause_loop

	call clean_screen
ret

menuman_init::
	
	ld hl, #0x0002
	call cpct_setDrawCharM0_asm
	ld iy, #str_menu
	X=15
	Y=40
	ld hl, #0xC000 + 64 * (Y /  8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #0x0004
	call cpct_setDrawCharM0_asm
	ld iy, #str_press_0
	X=7
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld iy, #str_press_1
	X=7
	Y=120
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld iy, #str_press_2
	X=7
	Y=160
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ret

menuman_instructions:
	ld hl, #0x0002
	call cpct_setDrawCharM0_asm
	ld iy, #str_press_1
	X=7
	Y=40
	ld hl, #0xC000 + 64 * (Y /  8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #0x0006
	call cpct_setDrawCharM0_asm
	
	;;MOVE
	ld iy, #str_press_1
	X=44
	Y=60
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	ld e,#charW
	call cpct_drawCharM0_asm

	X=7
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	ld e,#charA
	call cpct_drawCharM0_asm

	X=13
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	ld e,#charS
	call cpct_drawCharM0_asm

	X=19
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	ld e,#charD
	call cpct_drawCharM0_asm

	;;Rayas teclado
	;;Linea 1 (Encima de A S D)
	X=5 ;;[4-22]
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X - #0x50 + #0x2000

	ld e, #23 - 4
	pintaL1:
		ld (hl),#color_lines
		inc hl
		dec e
	jr nz, pintaL1


	;;Linea 2 (Debajo de A S D)
	X=5 ;;[4-22]
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X + #0x0850

	ld e, #23 - 4
	pintaL2:
		ld (hl),#color_lines
		inc hl
		dec e
	jr nz, pintaL2

	;;Linea 3 (Encima de W)
	X=43 ;;[42-48]
	Y=60
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X - #0x2000

	ld e, #48 - 42
	pintaL3:
		ld (hl),#color_lines
		inc hl
		dec e
	jr nz, pintaL3

	;;Lineas verticales
	X=5 ;;[42-48]
	Y=80

	ld e, #6
	ld bc,#0x800
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	pintaL4:
		ld (hl),#color_lines_v
		add hl,bc
		dec e
	jr nz, pintaL4

	ld e, #6
	ld bc,#0x800
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X + 6
	pintaL5:
		ld (hl),#color_lines_v
		add hl,bc
		dec e
	jr nz, pintaL5

	ld e, #6
	ld bc,#0x800
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X + 12
	pintaL6:
		ld (hl),#color_lines_v
		add hl,bc
		dec e
	jr nz, pintaL6

	ld e, #6
	ld bc,#0x800
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X + 18
	pintaL7:
		ld (hl),#color_lines_v
		add hl,bc
		dec e
	jr nz, pintaL7

	X=24 ;;[42-48]
	Y=60

	ld e, #6
	ld bc,#0x800
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X + 18 - #0x1000

	pintaL8:
		ld (hl),#color_lines_v
		add hl,bc
		dec e
	jr nz, pintaL8

	X=30 ;;[42-48]
	Y=60

	ld e, #6
	ld bc,#0x800
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X + 18 - #0x1000
	pintaL9:
		ld (hl),#color_lines_v
		add hl,bc
		dec e
	jr nz, pintaL9


	;;Texto move
	ld hl, #0x0004
	call cpct_setDrawCharM0_asm

	ld iy, #str_Move
	X=55
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	;;SHOOT
	ld hl, #0x0006
	call cpct_setDrawCharM0_asm

	ld iy, #str_space
	X=3
	Y=120
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #0x0004
	call cpct_setDrawCharM0_asm

	ld iy, #str_Shoot
	X=47
	Y=120
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	;;ESC
	ld hl, #0x0006
	call cpct_setDrawCharM0_asm

	ld iy, #str_esc
	X=3
	Y=160
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #0x0004
	call cpct_setDrawCharM0_asm

	ld iy, #str_EndGame
	X=39
	Y=160
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	;;PAUSE
	ld hl, #0x0006
	call cpct_setDrawCharM0_asm

	ld iy, #str_P
	X=3
	Y=200
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #0x0004
	call cpct_setDrawCharM0_asm

	ld iy, #str_pause_min
	X=51
	Y=200
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ret

menuman_credits:
	ld hl, #0x0002
	call cpct_setDrawCharM0_asm
	ld iy, #str_press_2
	X=7
	Y=40
	ld hl, #0xC000 + 64 * (Y /  8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #0x0004
	call cpct_setDrawCharM0_asm
	ld iy, #str_raquel
	X=7
	Y=80
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld iy, #str_carlos
	X=7
	Y=120
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld iy, #str_ivan
	X=7
	Y=160
	ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	; ld hl, #0x0004
	; call cpct_setDrawCharM0_asm
	; ld iy, #str_press_Space
	; X=7
	; Y=240
	; ld hl, #0xC000 + 64 * (Y/8) + 2048 * (Y & 7) + X
	; call cpct_drawStringM0_asm

	ret

menuman_run::
	call clean_screen

	menu_continue:
	call starfield_update
	call render_stars
	call menuman_init
	call esperar_menu

	call cpct_scanKeyboard_f_asm
	ld hl,#Key_1
	call cpct_isKeyPressed_asm
	jr nz,menuman_run_instructions

	call cpct_scanKeyboard_f_asm
	ld hl,#Key_2
	call cpct_isKeyPressed_asm
	jr nz,menuman_run_credits

	call cpct_scanKeyboard_f_asm
	ld hl,#Key_0
	call cpct_isKeyPressed_asm
	jr z,menu_continue
   
	ret

menuman_run_instructions:
	call clean_screen
	
	instructions_continue:
	call starfield_update
	call render_stars
	call menuman_instructions
	call esperar_menu

	call cpct_scanKeyboard_f_asm
	;ld hl,#Key_Space
	call cpct_isAnyKeyPressed_asm
	jr z,instructions_continue
jr menuman_run

menuman_run_credits:
	call clean_screen

	credits_continue:
	call starfield_update
	call render_stars
	call menuman_credits
	call esperar_menu

	call cpct_scanKeyboard_f_asm
	;ld hl,#Key_Space
	call cpct_isAnyKeyPressed_asm
	jr z,credits_continue
jr menuman_run