.include "man/starfieldman.h.s"

stars_array: .ds max_stars*tam_star
next_star_to_update: .dw #stars_array

num_colors = 1
colors:
    .db 0x2A
    .db 0x28
    .db 0x88

star_constructor:
    ;;Calculo posicion inicial
        ;;Calculamos bc=[0000-3FFF]
    call cpct_getRandom_lcg_u8_asm ;;return a = Random u8
    and a,#0xFF  ;;a = a%FF
    ld c,a

    call cpct_getRandom_lcg_u8_asm ;;return a = Random u8
    and a,#0x3F  ;;a = a%3F
    ld b,a

    ld hl,#0xC000 ;;Posicion inicial de memoria
    add hl,bc   ;;Calculo posicion inicial estrella

    ld (ix),l
    ld 1(ix),h  ;;Guardamos posicion
    
    ;;Calculo velocidad
    call cpct_getRandom_lcg_u8_asm
    and a,#0x38 ;; Poner and 0x38 para luego solo tener que sumarlo
    and a
    jr nz, nosuma
    ld a, #0x30 ;;Para que la velocidad no quede a 0

    nosuma:
    add a,#0x08 ;;Sumamos para que la velocidad sea 0x0800 - 0x4000
    ld 2(ix),a ;;Guardamos velocidad


    ;; Asignamos el color según la velocidad
    sub #0x19
    jr nc, next_color_1 
    ld b, #0
    jr end_select_color
next_color_1:
    sub #0x25
    jr nc, next_color_2
    ld b, #1
    jr end_select_color
next_color_2:
    ld b, #2
end_select_color:
    ld a, b
    ld c, a
    ld b, #0
    ld hl, #colors
    add hl, bc

    ld a, (hl)
    ld 3(ix), a

    ret

starfield_init:
    ;;Comprobamos si quedan estrellas por crear
    ld a,#max_stars
    ld  ix, #stars_array
    create_next_star:
        push af
        call star_constructor
        pop af
        ld bc,#tam_star
        add ix,bc
        dec a
    jr nz, create_next_star

    not_create_star:
ret

starfield_update:
    ;;Actualizamos posicion estrellas
;jr .
    ;;Comprobamos no salirnos del array

    ld bc,#tam_star_array+#stars_array
    ld hl,(next_star_to_update)
    
    ld a,h
    sub b
    jr nz,next_starX

    ld a,l
    ld b,c
    sub b

    jr nz,next_starX

    ;;Si nos salimos del array
    ld ix,#stars_array
    jr outOfBounds

    ;;Si no nos salimos del array
    next_starX:
    ld ix,(next_star_to_update)  ;;ix = puntero a estrella

    outOfBounds:
    ;ld ix,#stars_array
    ld c, #tam_star
    ld b,#0 ;;bc = tamaño estrella
    ;ld a,#stars_array
    ld a,#stars_per_frame
    ld e,a  ;;e = n estrellas

    loop_update_stars:
        push bc
        push de
        call update_coor_star
        pop de
        pop bc
        add ix,bc
        dec e
    jr nz,loop_update_stars

    ld (next_star_to_update),ix
ret

;;ENTRADA: ix -> puntero a estrella
update_coor_star:
    ld h,1(ix)
    ld l, (ix)

    ld (hl),#0x00   ;;Borramos posicion anterior

    ;;--------ACELERACION ESTRELLAS-------------------------------------
    ld a,h
    add #0x20

    ld h,a
    jr nc,end_calc_coor_star0    ;;Si no hay carry terminar
        ;;hl+0xC050
        ld bc,#0xC050
        add hl,bc

        jr nc,end_calc_coor_star0    ;;Si no hay carry terminar
            ld hl,#0xC000
            call cpct_getRandom_lcg_u8_asm ;;return a = Random u8
            and a,#31  ;;a = a%31
            ld c,a
            ld b,#0
            add hl,bc   ;;Calculo posicion inicial estrella

    end_calc_coor_star0:
    ;;------------------------------------------------------------------

    ld a,h
    ld h,2(ix)  ;;Velocidad
    add h
    
    ld h,a  ;;hl+0x800

    jr nc,end_calc_coor_star    ;;Si no hay carry terminar
        ;;hl+0xC050
        ld bc,#0xC050
        add hl,bc

        jr nc,end_calc_coor_star    ;;Si no hay carry terminar
            ld hl,#0xC000
            call cpct_getRandom_lcg_u8_asm ;;return a = Random u8
            and a,#31  ;;a = a%31
            ld c,a
            ld b,#0
            add hl,bc   ;;Calculo posicion inicial estrella

    end_calc_coor_star:

    ld 1(ix),h
    ld (ix),l

    ;;Comprobacion de seguridad por si fallan calculos
    ld b,#0xC0
    ld a,h
    sub a,b
    ret p
    ret z

    ;;Si ha fallado el calculo reiniciar estrella
    ld hl,#0xC000
    call cpct_getRandom_lcg_u8_asm ;;return a = Random u8
    and a,#31  ;;a = a%31
    ld c,a
    ld b,#0
    add hl,bc   ;;Calculo posicion inicial estrella
    ld 1(ix),h
    ld (ix),l
    
ret