;; 
;; Control IA
;; 
.include "man/entityman.h.s"
.include "man/patrolman.h.s"

aicontrolsys_stand_by::
    
    ld a,e_ai_pre_st(ix)   
    cp #e_st_patrol
    jr z,_ini_patrol

    ;;sigue nave principal
    ld a, e_x(iy)
    ld e_ai_x(ix),a
    ld a, #201
    ld e_ai_y(ix), a
    ld e_ai_pre_st(ix), #e_st_stand_by
    ld e_ai_st(ix), #e_st_move_to
    ret
    

_ini_patrol:
    
    ld e_ai_pre_st(ix), #e_st_stand_by
    ld e_ai_st(ix), #e_st_patrol

    ret

aicontrolsys_move_to::
    
    ld a, e_ai_x(ix)        ;;carga x objetivo en a
    sub e_x(ix)             ;; en a x objetivo - x
    jr nc, _objx_greater_or_equal     ;; if (x objetivo -x >0)

_objx_lesser:
    ld a, e_ai_vx(ix)
    neg
    ld e_vx(ix), a
    jr _endif_x
_objx_greater_or_equal:
    jr z, _objx_arrived
    ld a, e_ai_vx(ix)
    ld e_vx(ix), a
    jr _endif_x
_objx_arrived:
    ld e_vx(ix), #0

_endif_x:

    ld a, e_ai_y(ix)        ;;carga y objetivo en a
    sub e_y(ix)             ;; en a y objetivo - y
    jr nc, _objy_greater_or_equal     ;; if (y objetivo -y >0)

_objy_lesser:
    ld a, e_ai_vy(ix)
    neg
    ld e_vy(ix), a
    jr _endif_y
_objy_greater_or_equal:
    jr z, _objy_arrived
    ld a, e_ai_vy(ix)
    ld e_vy(ix), a
    jr _endif_y
_objy_arrived:
    ld e_vy(ix), #0
    ld a,e_vx(ix)
    or a
    jr nz, _endif_y

    ;;x e y son 0
    ld a, e_ai_pre_st(ix)
    ld e_ai_st(ix), #e_st_stand_by
    ld e_ai_pre_st(ix), a

_endif_y:
    ret

aicontrolsys_patrol::
    
    ld l,e_ai_c_patrol_l(ix)
    ld h,e_ai_c_patrol_h(ix)

    ;;comprobar -1
    ld a,(hl)   ;; a=x    
    cp #patrol_invalid_move_x
    jr z,_reset_patrol

    ;;set a y
    ld e_ai_x(ix), a
    inc hl          ;;point to y
    ld a,(hl)       
    ld e_ai_y(ix), a

    ;; siguiente posicion de patrulla
    inc hl          
    ld e_ai_c_patrol_l(ix),l
    ld e_ai_c_patrol_h(ix),h

    ;;cambiar a move_to
    ld e_ai_pre_st(ix), #e_st_patrol
    ld e_ai_st(ix), #e_st_move_to

    ret

_reset_patrol:
    ;; inicio de la patrulla
    inc hl
    ld a,(hl)
    inc hl
    ld h,(hl)

    ;;reset patrulla
    ld e_ai_c_patrol_l(ix),a
    ld e_ai_c_patrol_h(ix),h
    
    ret

;; Actualizamos el estado del disparo de la IA
aicontrolsys_update_shoot:
    ;; Comprobamos si le toca disparar
    ld a, e_ai_shoot(ix)
    or a
    jr z, shoot

    ;; Si no dispara decrementamos el contador
    no_shoot:
        ld a, e_ai_shoot(ix)
        dec a
        ld e_ai_shoot(ix), a
        ret
    ;; Si dispara, generamos una bala y resetamos contador
    shoot:
        ;; Obtenemos número al azar y lo asignamos
        call cpct_getRandom_lcg_u8_asm
        and #7
        ld b, e_ai_shoot_time(ix)
        add b
        ld e_ai_shoot(ix), a

        ;; Generemos una nueva bala
        push ix

        ld a, e_cmp2(ix)
        and #e_cmp2_bomb
        jr z, shoot_torret

        ld hl, #bomb
        call spawnman_enemy
        jr end_sh

        shoot_torret:            
            ld a, e_cmp(ix)
            and #e_cmp_dead_y
            jr z, shoot_normal

            ld a, e_x(ix)
            add #-1
            ld e_x(ix), a

            ld hl, #bullet_ai
            call spawnman_enemy

            ld a, e_x(ix)
            add #2
            ld e_x(ix), a

            ld hl, #bullet_ai
            call spawnman_enemy

            ld a, e_x(ix)
            add #-1
            ld e_x(ix), a

            jr end_sh

        shoot_normal:
            ld hl, #bullet_ai
            call spawnman_enemy

        end_sh:

        pop ix

    ret

;; Actualizamos una entidad
aicontrolsys_update_entity::
    ;; Comprobamos si dispara
    ld a, e_cmp(ix)
    and #e_cmp_shoot
    call nz, aicontrolsys_update_shoot

    ;; Si no es IA pasamos al siguiente
    ld a, e_ai_st(ix)
    cp #e_st_no_ai
    ret z

    ;; Actualizamos según el estado 
    cp #e_st_stand_by
    call z,aicontrolsys_stand_by
    cp #e_st_move_to
    call z,aicontrolsys_move_to
    cp #e_st_patrol
    call z,aicontrolsys_patrol

    ret

;; Actualizamos las entidades de tipo IA
aicontrolsys_update::
    
    ld (_ent_array_ptr_temp_standby),ix
    _ent_array_ptr_temp_standby= .+2
    ld iy,#0x0000

    ld hl, #aicontrolsys_update_entity
    call entityman_doForAll
    ret