;;
;; ANIMATION MANAGER
;; 

.include "man/entityman.h.s"

;; Actualizamos la animacion de una entidad
animation_update_entity:

    ;; Comprobamos si es de tipo animación
    ld a, e_cmp(ix)
    and #e_cmp_animate
    ret z

    ;; Sprite actual de la animación
    ld e, e_anim_ptrL(ix)
    ld d, e_anim_ptrH(ix)

    ;; Guaramos hl en de
    ex de, hl

    continueAnim:

        ;; HL -> Apuntar hacia siguiente sprite
        ld c, (hl)
        inc hl
        ld b, (hl)
        inc hl

        ;; Si la animación es nullptr, se resetea     
        ld a, c
        or b
        jr z, resetAnim

        ;; Guardamos el siguiente sprite
        ld e_anim_ptrL(ix), l
        ld e_anim_ptrH(ix), h

        ;; Apuntamos el sprite que tiene dibujar 
        ld e_spH(ix), c
        ld e_spL(ix), b

        ;; Devolvemos el valor a de
        ex de, hl
        ret 

    resetAnim:
        ;; Ponemos la animación en el primer sprite
        ld a, (hl)
        inc hl
        ld h, (hl)
        ld l, a
        jr continueAnim

;; Actualizamos el estado de todas las entidades con animaciones
animation_update::
    ld hl, #animation_update_entity
    call entityman_doForAll
    ret