;;
;; INPUT
;;
.include "man/spawnman.h.s"
.include "man/gameman.h.s"

velocidad_x == #2
velocidad_y == #3

inputsys_R::
;; Escanear teclado
    call cpct_scanKeyboard_f_asm
    
;; Comprobamos la tecla espacio
    ld hl, #Key_R
    call cpct_isKeyPressed_asm
    ret z   ;;Not pressed

    call restart

ret

;; Actualiza las velocidades de una entidad a partir de los inputs
;; PARAMETROS
;; IX -> Entidad a actualizar
;; REGISTROS USADOS: HL, DE, BC, A, IY
inputsys_update::

    ;; Si la altura de la nave no esta completa no puede mover la nave
    ld a, e_h(ix)
    sub #36
    ret c

    call spawnman_update_time_shoots

    ;; Resetear velocidades de la entidad 
    ld e_vx(ix), #0
    ld e_vy(ix), #0

    ;; Escanear teclado
    call cpct_scanKeyboard_f_asm

;; Comprobamos la tecla A
    ld hl, #Key_A 
    call cpct_isKeyPressed_asm
    jr z, A_NotPressed

A_Pressed:
    ;;Controlamos que no salga de la posicion
    ld a, e_x(ix)       ;;Posicion x
    ld b, #velocidad_x  ;;Velocidad
    sub a,b
    jr c,#A_NotPressed ;;Si no hay carry = si se sale del limite

    ld e_vx(ix), #-velocidad_x
A_NotPressed:
    ld hl, #Key_D
    call cpct_isKeyPressed_asm
    jr z, D_NotPressed

;; Comprobamos la tecla D
D_Pressed:
    ;;Controlamos que no salga de la posicion
    ld a, #velocidad_x  ;;Velocidad
    ld b, e_w(ix)       ;;Ancho nave
    add a,b
    ld b, e_x(ix)       ;;Posicion x
    add a,b
    sub #80             ;;Ancho pantalla
    jr nc,#D_NotPressed ;;Si no hay carry = si se sale del limite

    ld e_vx(ix), #velocidad_x
D_NotPressed:
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr z, Space_NotPressed

;; Comprobamos el Espacio
Space_Pressed:
    ld hl, #bullet
    call spawnman_hero
Space_NotPressed:
    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr z, E_NotPressed

;; Comprobamos el Espacio
E_Pressed:
    call game_over
E_NotPressed:
    ld hl, #Key_W
    call cpct_isKeyPressed_asm
    jr z, W_NotPressed

W_Pressed:
    ;;Controlamos que no salga de la posicion
    ld a, #velocidad_y  ;;Velocidad
    ld b, e_y(ix)       ;;Ancho nave
    add a,b
    sub #130             ;;Ancho pantalla
    jr c,#W_NotPressed ;;Si no hay carry = si se sale del limite

    ld e_vy(ix), #-velocidad_y

W_NotPressed:
    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    jr z, P_NotPressed

P_Pressed:
    call menuman_run_pause

P_NotPressed:
    ld hl, #Key_S
    call cpct_isKeyPressed_asm
    jr z, S_NotPressed

S_Pressed:
    ;;Controlamos que no salga de la posicion
    ld a, #velocidad_y  ;;Velocidad
    ld b, e_h(ix)       ;;Ancho nave
    add a,b
    ld b, e_y(ix)       ;;Posicion x
    add a,b
    sub #200           ;;Ancho pantalla
    jr nc,#S_NotPressed ;;Si no hay carry = si se sale del limite

    ld e_vy(ix), #velocidad_y
S_NotPressed:
    ret

ret