;;
;; RENDER SYSTEM
;;
.include "man/entityman.h.s"
.include "man/heroman.h.s"
.include "man/starfieldman.h.s"

coords_puntuacion = #0xC84C ;;El score esta alineado hacia la izquierda
posMem_balas = #0xC0A1 ;;Hay que cambiar la direccion
level_str: .asciz "Level"
score_str: .asciz "SC"
high_str: .asciz "HI"
color_change: .db 0
temp_update_bonus: .db 0
temp_update_hearts: .db 0
width_char = #4
barra_w_bala = #5
barra_h = #5


palette: 
    ;.db 0x54, 0x4a, 0x53, 0x4c, 0x4b, 0x54, 0x55, 0x4d, 0x46, 0x5e, 0x5f, 0x47, 0x52, 0x59, 0x4a, 0x47
    ;;0 8 4 18 17 6 26 2 11 10 11 15    3 19 13 1 
    .db 0x54, 0x4d, 0x58, 0x4a, 0x5b, 0x4c, 0x4b, 0x55, 0x57, 0x47, 0x46, 0x4e, 0x5c, 0x52, 0x40, 0x44

render_balasRest:
    ;;PRIMERA PARTE DE LA BARRA
    ld a,(free_balas_mainShip)
    ld hl,#posMem_balas

    and a
    jr z,barra2

    next_bala:
        push hl         ;;Guardamos posicion de mem video
        push af

        ex de, hl       ;; Dirección de memoria donde dibujar
        ld c,#barra_w_bala   ;; Obtener W
        ld b,#barra_h   ;; Obtener H
        ld a,#0xF3   ;;Color
        call cpct_drawSolidBox_asm

        pop af
        pop hl
        ld bc,#barra_w_bala
        add hl,bc   ;;Recolocamos puntero

        dec a
        jr nz, next_bala
    

    ;;SEGUNDA PARTE DE LA BARRA
    barra2:
    ld a,(free_balas_mainShip)
    ld b,a
    ld a,#max_balas_mainShip

    sub b ;;a = balas gastadas

    and a
    ret z
    next_bala_gast:
        push hl         ;;Guardamos posicion de mem video
        push af

        ex de, hl       ;; Dirección de memoria donde dibujar
        ld c,#barra_w_bala   ;; Obtener W
        ld b,#barra_h   ;; Obtener H
        ld a,#0xf0   ;;Color
        call cpct_drawSolidBox_asm

        pop af
        pop hl
        ld bc,#barra_w_bala
        add hl,bc   ;;Recolocamos puntero

        dec a
        jr nz, next_bala_gast
ret

render_stars::
    ld ix,#stars_array
    ld c, #tam_star
    ld b,#0
    ld a,#max_stars
    ld e,a

    loop_render_stars:
        ld h,1(ix)
        ld l,(ix)
        ld a, 3(ix)
        ld (hl),a
        add ix,bc
        dec e
    jr nz,loop_render_stars
ret

;;Entrada: a --> Numero
;;Salida: e --> ascii del numero
rendersys_num_to_ascii:
    ld b,#0x30
    add b
    ld e,a
    ret

;;ENTRADA:  a -> byte a dibujar
;;          hl -> Posicion de memoria de video (alineado hacia izquierda)
render_byte:
    ld b,a  ;;Hacemos copia en b
    ld e,#2
    next_digito:
        push de
        push bc
        push hl

        ;;Mostrar digito
        and #0x0F  ;;Ponemos en a la ult. cifra
        call rendersys_num_to_ascii
        pop hl
        ;;e = ascii a pintar
        ld bc,#-width_char
        add hl,bc  ;;Posicion en memoria de video
        push hl
        call cpct_drawCharM0_asm

        ;;Siguiente digito
        pop hl
        pop bc
        pop de
        ld a,b
        rra
        rra
        rra
        rra     ;;Desplazamos medio byte a la derecha
        ld b,a  ;;Hacemos copia en b
        dec e
    jr nz,next_digito
ret

;;ENTRADA:  ix -> coordenadas de la palabra a dibujar
;;          hl -> Posicion de memoria de video (alineado hacia izquierda)
render_word:
    ;;BYTE 1
    ld a,(ix)   ;;Byte 1
    push hl
    push ix
    call render_byte
    pop ix
    pop hl

    ;;BYTE 2
    ld bc,#-width_char*2
    add hl,bc   ;;Memoria video
    inc ix
    ld a,(ix)   ;;Byte 2
    call render_byte
ret

render_score::
    ld h,#0   ;;Background colour index palette
    ld l,#3   ;;Foreground colour index palette
    call cpct_setDrawCharM0_asm

    ld iy,#score_str    ;;Pointer to string
    ld hl,#coords_puntuacion - #25   ;;Pointer to video_memory
    call cpct_drawStringM0_asm

    ld ix, #score
    ld hl, #coords_puntuacion
    call render_word

    ld h,#0   ;;Background colour index palette
    ld l,#8   ;;Foreground colour index palette
    call cpct_setDrawCharM0_asm

    ld iy,#high_str    ;;Pointer to string
    ld hl,#coords_puntuacion +#0x50 - #25   ;;Pointer to video_memory
    call cpct_drawStringM0_asm

    ;;Mostrar high score
    ld ix,#high_score
    ld hl, #coords_puntuacion+#0x50
    call render_word
ret

render_level::
    ld h,#0   ;;Background colour index palette
    ld l,#3   ;;Foreground colour index palette
    call cpct_setDrawCharM0_asm

    ld iy,#level_str    ;;Pointer to string
    ld hl,#0xC000 + #30   ;;Pointer to video_memory
    call cpct_drawStringM0_asm

    ; ld a,(num_level)
    ; call rendersys_num_to_ascii
    ; ;;e = ascii a pintar
    ; ld hl, #0xC850+#38  ;;Posicion en memoria de video
    ; call cpct_drawCharM0_asm
    ld a,(num_level)
    ld hl, #0xC850+#42  ;;Posicion en memoria de video
    call render_byte

    ret

rendersys_draw_game_over_str::
    ld h,#0   ;;Background colour index palette
    ld l,#3   ;;Foreground colour index palette
    call cpct_setDrawCharM0_asm

    ld iy,#str_game_over    ;;Pointer to string
    ld hl,#0xD000   ;;Pointer to video_memory
    call cpct_drawStringM0_asm

;;PRUEBAS:
    ; ld hl,#0xD050
    ; ld e,#0x48  ;;ascii de H
    ; call cpct_drawCharM0_asm

    ; ld hl,#0xD0A0
    ; ld a,#0x48  ;;ascii de H
    ; call cpct_drawCharM0_inner_asm
ret

rendersys_draw_gameover_screen::
    ld l,#3   ;;Foreground colour
    ld h,#0   ;;Background colour
    call cpct_setDrawCharM0_asm

    ld hl,#0xC334   ;;Memoria de video
    ld iy,#str_game_over    ;;Puntero a string
    call cpct_drawStringM0_asm

    ld hl,#0xC3D7   ;;Memoria de video
    ld iy,#str_pressR    ;;Puntero a string
    call cpct_drawStringM0_asm
ret
render_hearts:
    ld a, (temp_update_hearts)
    or a 
    jr z, render_next_hearts

    dec a
    ld (temp_update_hearts), a

    render_next_hearts:
    ld a, #5
    ld (temp_update_hearts), a
    ld a,(lifes)
    ld hl,#posMem_heart

    sub #0
    ret z
    next_heart:
        push hl         ;;Guardamos posicion de mem video
        push af

        ex de, hl       ;; Dirección de memoria donde dibujar
        ld hl,(sprt_heart) ;; Sprite
        ld c,#heart_w   ;; Obtener W
        ld b,#heart_h   ;; Obtener H
        call cpct_drawSprite_asm

        pop af
        pop hl
        ld bc,#heart_w + #dist_hearts
        add hl,bc   ;;Recolocamos puntero

        dec a
        jr nz, next_heart
    ret

;; Inicializa el sistema de renderizado
rendersys_init::

    call cpct_disableFirmware_asm
	
    ld c,#0
    call cpct_setVideoMode_asm
    
    ld hl, #palette
	ld de, #16
	call cpct_setPalette_asm

    ret 

rendersys_bonus::

    ld a, (temp_update_bonus)
    or a
    jr z, n_bonus

    dec a
    ld (temp_update_bonus), a
    ret

    n_bonus:
    ld a, #5
    ld (temp_update_bonus), a
    
    ld de, #coords_puntuacion + #0x50 + #0x50 - #0x05
    ld a, #0x00
    ld c, #5
    ld b, #16
    call cpct_drawSolidBox_asm

    ld de, #coords_puntuacion + #0x50 + #0x50 - #0x0A
    ld a, #0x00
    ld c, #5
    ld b, #16
    call cpct_drawSolidBox_asm

    ld a, (double_score_time)
    or a
    jr z, next_1

    ld de, #coords_puntuacion + #0x50 + #0x50 - #0x05
    ld hl, #_doubleshoot_2
    ld c, #5
    ld b, #16
    call cpct_drawSprite_asm

    ld de, #coords_puntuacion + #0x50 + #0x50 - #0x0A
    jr next

    next_1:
        ld de, #coords_puntuacion + #0x50 + #0x50 - #0x05
    next:

    ld a, (double_shoot_time)
    or a
    jr z, end

    ld hl, #_doubleshoot_0
    ld c, #5
    ld b, #16
    call cpct_drawSprite_asm

    end:

    ret


;; Dibujar sprite de una entidad 
;; PARAMETROS
;; ix -> Puntero a la entidad a actualizar
;; REGISTROS USADOS: ix, af, de, hl 
rendersys_update_entity::

    ld a, e_cmp2(ix)
    and #e_cmp2_render
    jr nz, checkDead

    ;; Borrar instancia anterior
    ld e, e_lastVPL(ix) ;; Dirección de memoria anterior
    ld d, e_lastVPH(ix) ;; Dirección de memoria anterior
    xor a               ;; A = 0 -> Color de fondo
    ld c, e_w(ix)      ;; Width
    ld b, e_h(ix)       ;; Height
    call cpct_drawSolidBox_asm

    checkDead:
    ;; Comprobamos que es una entidad válida
    ld a, e_cmp(ix)
    and #e_cmp_dead
    ret nz 

    ;; Obtenemos la dirección de memoria donde dibujar el sprite
    ld de, #0xC000 ;; Dirección de memoria de video
    ld b, e_y(ix)  ;; Y
    ld c, e_x(ix)  ;; X
    call cpct_getScreenPtr_asm

    ;; Almacenar la dirección de memoria
    ld e_lastVPL(ix), l
    ld e_lastVPH(ix), h

    ex de, hl       ;; Dirección de memoria donde dibujar
    ld h, e_spL(ix) ;; Sprite
    ld l, e_spH(ix) ;; Sprite
    ld c, e_w(ix)
    ld b, e_h(ix)
    call cpct_drawSprite_asm
    
    ret

rendersys_transition_between_levels:
    ld a, (time_pause)
    or a 
    ret z
    
    ld a, (color_change)
    or a
    jr z, yellow

    ld a, #0
    ld (color_change), a
    ld h,#0   ;;Background colour index palette
    ld l,#6   ;;Foreground colour index palette

    jr continue

    yellow:
        ld a, #1
        ld (color_change), a
        ld h,#0   ;;Background colour index palette
        ld l,#3   ;;Foreground colour index palette

    continue:

    call cpct_setDrawCharM0_asm

    ld iy,#level_str    ;;Pointer to string
    ld hl,#0xDb20 + #25  ;;Pointer to video_memory
    call cpct_drawStringM0_asm

    ; ld a,(num_level)
    ; call rendersys_num_to_ascii
    ; ;;e = ascii a pintar
    ; ld hl, #0xDb20+#48  ;;Posicion en memoria de video
    ; call cpct_drawCharM0_asm
    ld a,(num_level)
    ld hl,#0xDb20+#56
    call render_byte

    ret

rendersys_clear_transition_between_levels::
    ld h,#0   ;;Background colour index palette
    ld l,#0   ;;Foreground colour index palette
    call cpct_setDrawCharM0_asm
    
    ld iy,#level_str    ;;Pointer to string
    ld hl,#0xDb20 + #25  ;;Pointer to video_memory
    call cpct_drawStringM0_asm

    ld a,(num_level)
    ;call rendersys_num_to_ascii
    ;;e = ascii a pintar
    ld hl, #0xDb20+#56  ;;Posicion en memoria de video
    ;call cpct_drawCharM0_asm
    call render_byte

    ret


;; Dibujamos los sprites en pantalla
;; PARAMETROS
;; ix -> Puntero al primer elemento del vector
;; a -> Número de elementos del vector
;; REGISTROS USADOS: ix, af, de, hl 
rendersys_update::
    call render_stars

    call entityman_getEntityVector_IX
    call entityman_getNumEntities_A
    ld hl, #rendersys_update_entity
    call entityman_doForAll
    call render_score
    call render_hearts
    call render_balasRest
    call render_level
    call rendersys_bonus
    call rendersys_transition_between_levels
    ret

clean_screen:
    ld de,#0xC000
    ld a,#0x00
    ld c,#40
    ld b,#200
    call cpct_drawSolidBox_asm

    ld de,#0xC000+#40
    ld a,#0x00
    ld c,#40
    ld b,#200
    call cpct_drawSolidBox_asm
ret